unit main;

interface

//      
// JEDI Code Library - http://sourceforge.net/project/showfiles.php?group_id=47514
// Graphics32 - http://g32.org

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, GR32_Image, ExtCtrls, Mask, JvMaskEdit, JvSpin;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    img: TImage32;
    Button1: TButton;
    Button2: TButton;
    chbRandom: TCheckBox;
    edtA: TJvSpinEdit;
    edtB: TJvSpinEdit;
    edtC: TJvSpinEdit;
    pnlParams: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    chbRndColor: TCheckBox;
    cmbFormula: TComboBox;
    Label4: TLabel;
    lblPoints: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure chbRandomClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses
   GR32, JclMath ;

{$R *.DFM}

var
  a, b, c, zx, zy: Integer;
  X, Y, X1, Y1: Real;
  StopFlag : Boolean ; //  
  Cycle : Longword ; //   =   

procedure TfrmMain.Button1Click(Sender: TObject);
var
  h,w : Integer ; //    
  Color : TColor32 ; //   
begin
  StopFlag := False ; // .. 
  Cycle := 0 ; //   

  X := 0; Y := 0; //    0-0
  h := img.Height div 2 ;
  w := img.Width div 2 ;
  Color := clWhite32 ; //   - 
  Randomize ;

  //    

  if chbRandom.Checked then
  begin
    A := Random ( 100  ) ;
    B := Random ( 10   ) ;
    C := Random ( 1000 ) ;
    edtA.Value := a ;
    edtB.Value := b ;
    edtC.Value := c ;
    edtA.Invalidate ;
    edtB.Invalidate ;
    edtC.Invalidate ;
  end else
  begin
    a := Trunc(edtA.Value) ;
    b := Trunc(edtB.Value) ;
    c := Trunc(edtC.Value) ;
  end ;

  //      

  img.Bitmap.SetSize(img.Width,img.Height) ;
  img.Bitmap.Clear ;

  //   

  repeat

    Inc (Cycle) ; //   

    //         
    case cmbFormula.ItemIndex of
     0 : X1 := Y - sgn (X) * sqrt (Abs (b * X - c) );
     1 : X1 := Y - sgn (X) * sin (Abs (b * X - c) );
     2 : X1 := Y - sgn (X) * cos (Abs (b * X - c) );
     3 : X1 := Y - sgn (X) * tan (Abs (b * X - c) );
    end ;

    Y1 := a - X;

    //   
    zx := Trunc ( w + X1 ) ;
    zy := Trunc ( h + Y1 ) ;

    //      
    img.Bitmap.PixelS[zx,zy] := Color ;

    //      
    X := X1; Y := Y1;

    //   100 
    if (Cycle mod 100) = 0 then
    begin
      //  -
      lblPoints.Caption := 'Points: '+ IntToStr(Cycle) ;

      //     3000,  
      if ((Cycle mod 3000) = 0) and chbRndColor.Checked then
        Color := Color32(Random(255),Random(255),Random(255)) ;
      //  ,   
      img.Invalidate ;
      //    
      Application.ProcessMessages ;
    end ;

  // ,  -   StopFlag
  until StopFlag ;
end;


procedure TfrmMain.Button2Click(Sender: TObject);
begin
  StopFlag := True ;
end;

procedure TfrmMain.chbRandomClick(Sender: TObject);
begin
  pnlParams.Enabled := not chbRandom.Checked ;
  edtA.Enabled := not chbRandom.Checked ;
  edtB.Enabled := not chbRandom.Checked ;
  edtC.Enabled := not chbRandom.Checked ;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  StopFlag := True ;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  cmbFormula.ItemIndex := 0 ;
end;

end.
